var User = require('../models/user')
,   passport = require('passport');

// Render all users
module.exports.list = function (req, res, next) {
  User.find()
      .sort({ createdAt: 'descending'})
      .exec(function (err, users) {
        if (err) { return next(err); }
        if (!users) { return next(404) }
        console.log(req.headers);
        if (req.headers.accept.indexOf('application/json') >= 0) {
          res.json(users);
        } else {
          res.render('user_views/user_list', { users: users });
        }
      });
}

// Get user by ID
module.exports.get = function (req, res, next) {
  User.findOne({ username: req.params.username})
      .exec(function (err, user) {
        if (err) { return next(err) }
        if (!user) { return next(404) }

        // if (req.accepts('json')) {
        //   res.json(user);
        // } else {
          res.render('user_views/user_profile', { user: user });
        // }
      });
}

// Create User
module.exports.create = function (req, res, next) {
  
  var username = req.body.username;
  var password = req.body.password;

  User.findOne({ username: username }, function (err, user) {

    if (err) { return next(err); }

    if (user) {
      req.flash('error', "User already exists");
      return res.redirect('/signup');
    }

    var newUser = new User({
      username: username,
      password: password
    });

    newUser.save(function (err) {
      if (err) { return next(err); }

      res.redirect('/');
    });

  });

}

// Delete User
module.exports.delete = function (req, res, next) {

  var username = req.body.username;

  // User.findOne

}

// Create session
module.exports.login = passport.authenticate('login', {
  successRedirect: '/',
  failureRedirect: '/login',
  failureFlash: true
});

// Login form
module.exports.loginForm = function (req, res, next) {
  res.render('user_views/forms/user_login', { title: 'login' });
}

// SignUp form
module.exports.signupForm = function (req, res, next) {
  res.render('user_views/forms/user_signup', { title: 'signup' });
}