var mongoose = require('mongoose')
,   bcrypt = require('bcrypt-nodejs')
,   SALT_FACTOR = 10;

var userSchema = mongoose.Schema({
  username: {
    type: String,
    require: true,
    unique: true
  },
  password: {
    type: String,
    require: true
  },
  createdAt: {
    type: Date,
    default: Date.now
  },
  bio: String,
  perms: {
    type: Array,
    default: ['basic']
  }
});

// Not sure what this is for, need to look it up
var noop = function () {};

userSchema.pre('save', function (done) {
  var user = this;

  if (!user.isModified('password')) {
    return done();
  }

  bcrypt.genSalt(SALT_FACTOR, function (err, salt) {

    if (err) {return done(err)}

    bcrypt.hash(user.password, salt, noop, function (err, hashedPassword) {

      if (err) {return done(err)}

      user.password = hashedPassword;
      done();
    });
  })
});

userSchema.methods.checkPassword = function (guess, done) {
  bcrypt.compare(guess, this.password, function (err, isMatch) {
    done(err, isMatch);
  });
}

userSchema.methods.name = function () {
  return this.username;
}

var User = mongoose.model('User', userSchema);

module.exports = User;