var express = require('express')
,   app = express()
,   path = require('path')
,   mongoose = require('mongoose')
,   bodyParser = require('body-parser')
,   cookieParser = require('cookie-parser')
,   flash = require('connect-flash')
,   passport = require('passport')
,   session = require('express-session')
,   passportConfig = require('./config/passport')
,   routes = require('./app/routes')(app);


// Connect to MongoDB
mongoose.connect('mongodb://localhost:27017/templates');

app.set('views', __dirname + '/app/views');
app.set('view engine', 'jade');

app.set('port', (process.env.PORT || 5000));

// Static links
app.use('/public', express.static(path.join(__dirname, '/public')));
app.use('/bower', express.static(path.join(__dirname, '/bower_components')));

// Setup utilities
app.use(bodyParser.urlencoded({
  extended: false
}));
app.use(flash());
app.use(cookieParser());
app.use(session({
  secret: 'Lucille', // Replace this later (and have a config of some kind)
  resave: true,
  saveUninitialized: true
}));

// Configure passport
passportConfig();
app.use(passport.initialize());
app.use(passport.session());

app.use(routes);

app.listen(app.get('port'), function() {
  console.log("Node app is running at localhost:" + app.get('port'));
});