define(function (require) {
  'use strict';

  var angular = require('angular')
  ,   ngConfig = require('./ng-config')
  ,   assignUserDir = require('./directives/userDirectives')
  ,   workoutCtrl = require('./controllers/workoutCtrl')
  ,   userCtrl = require('./controllers/userCtrl')
  ,   app = angular.module('workoutApp', []);

  // Config the app
  ngConfig.setSymbols(app, '#{', '}');

  // Assign Directives
  assignUserDir(app);

  // Add the user controller
  app.controller('userCtrl', userCtrl);

  // Add the workout controller
  app.controller('workoutCtrl', workoutCtrl);

  app.init = function () {
    angular.bootstrap(document, ['workoutApp']);
  }

  return app

});